package com.FranckBarbier.Saxon_XQuery;

class Handler extends org.xml.sax.helpers.DefaultHandler {

    public Handler() {
        super();
    }

    @Override
    public void characters(char[] data, int start, int length) {
//        System.out.println(data);
    }

    @Override
    public void startElement(String uri, String localName, String qName, org.xml.sax.Attributes attributes) {
        System.out.println("qName: " + qName + " localName: " + localName);
    }

    @Override
    public void endDocument() {
        System.out.println("Fin...");
    }

    @Override
    public void startDocument() {
        System.out.println("Début...");
    }

    /**
     * Actions à réaliser lors de la détection de la fin d'un élément.
     */
    public void endElement(String name) {
        System.out.println("Fin tag " + name);
    }

    /**
     * Actions à réaliser lors de la détection d'un nouvel élément.
     */
    public void startElement(String name, org.xml.sax.AttributeList atts) {
        System.out.println("debut tag : " + name);
    }
}

public class Saxon_XQuery {

    public static void main(String[] args) {
        try {
            // _Display(new java.io.FileInputStream(new java.io.File("./data/PF.xqy")));
//           _Display(new java.io.FileInputStream(new java.io.File("./data/PF_.xqy")));
//           _Display(new java.io.FileInputStream(new java.io.File("./data/PF_reference.xqy")));
//            _Display(new java.io.FileInputStream(new java.io.File("./data/Article_reference_designation.xqy")));
//            _Display(new java.io.FileInputStream(new java.io.File("./data/Composants.xqy")));
//            _Display(new java.io.FileInputStream(new java.io.File("./data/CH005_comme_composant.xqy")));
//            _Display(new java.io.FileInputStream(new java.io.File("./data/CH005_comme_composant_.xqy")));
//            _Display(new java.io.FileInputStream(new java.io.File("./data/PLM_source_TO_PLM_target.xqy")));
//            _Display(new java.io.FileInputStream(new java.io.File("./data/PLM_source_TO_PLM_target_.xqy")));
            _Display(new java.io.FileInputStream(new java.io.File("./data/Transformation_inverse.xqy")));
//            _Display(new java.io.FileInputStream(new java.io.File("./data/Prison_de_Nantes/Nombre_de_condamnations.xqy")));
//            _Display(new java.io.FileInputStream(new java.io.File("./data/Prison_de_Nantes/En_preventive.xqy")));

//            _Display(new java.io.FileInputStream(new java.io.File("./data/CH005_comme_composant.xqy")));
        } catch (java.io.FileNotFoundException | javax.xml.xquery.XQException e) {
            e.printStackTrace();
        }

        try {
            _XInclude();
        } catch (java.io.IOException | javax.xml.parsers.ParserConfigurationException | org.xml.sax.SAXException e) {
            e.printStackTrace();
        }
    }

    private static void _Display(java.io.InputStream xquery_file) throws java.io.FileNotFoundException, javax.xml.xquery.XQException {
        javax.xml.xquery.XQConnection connection = (new com.saxonica.xqj.SaxonXQDataSource()).getConnection();
        javax.xml.xquery.XQPreparedExpression expression = connection.prepareExpression(xquery_file);
        javax.xml.xquery.XQResultSequence result = expression.executeQuery();
        while (result.next()) {
            System.out.println(result.getItemAsString(null));
        }
    }

    private static void _XInclude() throws java.io.IOException, javax.xml.parsers.ParserConfigurationException, org.xml.sax.SAXException {
        // https://xerces.apache.org/xerces2-j/
        // https://xerces.apache.org/xerces2-j/faq-xinclude.html
        // https://jmdoudoux.developpez.com/cours/developpons/java_new/chap-sax.php
        javax.xml.parsers.SAXParserFactory spf = javax.xml.parsers.SAXParserFactory.newInstance();
        spf.setNamespaceAware(true);
        spf.setXIncludeAware(true);

        javax.xml.parsers.SAXParser parser = spf.newSAXParser();
        assert (parser.isXIncludeAware());
        assert (parser.isNamespaceAware());
        parser.parse(new java.io.File("./data/XInclude/PLM.xml"), new Handler());
    }
}
